#if !defined(PCE_DEF)
#define PCE_DEF
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	"m6502.h"
#include "pcecd.h"

extern UChar *zp_base;
typedef struct tagIO {
	pair VDC[32];
//	byte VDC_ratch[32];
	pair VCE[0x200];
	pair vce_reg;
	/* VDC */
	word vdc_inc,vdc_raster_count;
	byte vdc_reg,vdc_status,vdc_ratch,vce_ratch;
//	byte vdc_iswrite_h;
	byte vdc_satb;
	byte vdc_pendvsync;
	int bg_h,bg_w;
	int screen_w,screen_h;
	int scroll_y;
	int minline, maxline;
	/* joypad */
	byte JOY[16];
	byte joy_select,joy_counter;
	/* PSG */
	byte PSG[6][8],wave[6][32],wavofs[6];
	byte psg_ch,psg_volume,psg_lfo_freq,psg_lfo_ctrl;
	/* TIMER */
	byte timer_reload,timer_start,timer_counter;
	/* IRQ */
	byte irq_mask,irq_status;
	/* CDROM extention */
	/*int backup,adpcm_firstread;
	pair adpcm_ptr;
	word adpcm_rptr,adpcm_wptr;*/
	/* CDROM extention */
  int backup,adpcm_firstread;
  byte cd_port_1800;
  byte cd_port_1801;
  byte cd_port_1802;
  byte cd_port_1804;

  /* Adpcm related variables */
  pair adpcm_ptr;
  word adpcm_rptr,adpcm_wptr;
  word adpcm_dmaptr;
  byte adpcm_rate;
  unsigned adpcm_pptr; /* to know where to begin playing adpcm (in nibbles) */
  unsigned adpcm_psize; /* to know how many 4-bit samples to play */

  /* Arcade Card variables */
  UInt32 ac_base[4];     /* base address for AC ram accessing */
  UInt16 ac_offset[4];   /* offset address for AC ram accessing */
  UInt16 ac_incr[4];     /* incrment value after read or write accordingly to the control bit */

  UChar  ac_control[4];  /* bit 7: unused
                          * bit 6: only $1AX6 hits will add offset to base
                          * bit 5 + bit 6: either hit to $1AX6 or $1AXA will add offset to base
                          * bit 4: auto increment offset if 0, and auto
                          *        increment base if 1
                          * bit 3: unknown
                          * bit 2: unknown
                          * bit 1: use offset address in the effective address
                          *   computation
                          * bit 0: apply autoincrement if set
                          */
  UInt32 ac_shift;
  UChar  ac_shiftbits;   /* number of bits to shift by */

/*        UChar  ac_unknown3; */
  UChar  ac_unknown4;

  byte io_buffer;
} IO ;

extern IO io;
void PutImage(int X,int Y,int W,int H);
int CartLoad(char *name);
void ResetPCE(M6502 *M);
int InitPCE(/*char *name*/);
void TrashPCE(void);
int InitMachine(void);
void TrashMachine(void);
int Joysticks(void);


extern UChar *PCM;
// The ADPCM array (0x10000 bytes)

//! A pointer to know where we're currently reading data in the cd buffer
extern UChar cd_sector_buffer[0x2000];

//! The real buffer into which data are written from the cd and in which we
//! takes data to gives it back throught the cd ports
extern UChar *cd_read_buffer;

//! extra ram provided by the system CD card
extern UChar cd_extra_mem[0x10000];





//! extra ram provided by the super system CD card
extern UChar cd_extra_super_mem[0x30000];

//! extra ram provided by the Arcade card
//extern UChar ac_extra_mem[0x200000];

//! remaining useful data in cd_read_buffer
extern UInt32 pce_cd_read_datacnt;

//! number of sectors we must still read on cd
extern UChar cd_sectorcnt;

//! number of the current command of the cd interface
extern UChar pce_cd_curcmd;


extern UChar CD_emulation;
// Do we handle CDs
/*
extern UChar CDBIOS_replace[0x4d][2];
// Used to know what byte do we have replaced


extern UChar use_eagle;
// Do we use eagle ?

extern UInt32 timer_60;
// how many times do the interrupt have been called
*/
extern UChar bcdbin[0x100];

extern UChar binbcd[0x100];

extern UInt32 pce_cd_sectoraddy;



/*typedef struct
{

  UInt32 offset;

  UChar new_val;

} PatchEntry;

typedef struct
{

  UInt32 StartTime;
  UInt32 Duration;
  char data[32];

} SubtitleEntry;

typedef enum
{
  HCD_SOURCE_REGULAR_FILE,
  HCD_SOURCE_CD_TRACK
} hcd_source_type;
*/
typedef struct
{
  UChar beg_min;
  UChar beg_sec;
  UChar beg_fra;

  UChar type;

  UInt32 beg_lsn;
  UInt32 length;

  //hcd_source_type source_type;
  char filename[256];

  UInt32 patch_number;
  UInt32 subtitle_number;

  UChar subtitle_synchro_type;

  //PatchEntry *patch;
 // SubtitleEntry *subtitle;

} Track;

//extern UInt32 HCD_first_track;
/* first track of emulated cd */

//extern UInt32 HCD_last_track;
/* last track of emulated cd */
extern Track CD_track[0x100];

extern UChar nb_max_track;


extern char *ISO_filename;

#define	NODATA	   0xff
#define	ENABLE	   1
#define	DISABLE	   0
#define AC_ENABLE_OFFSET_BASE_6 0x40
#define AC_ENABLE_OFFSET_BASE_A 0x20
#define AC_INCREMENT_BASE 0x10
#define AC_USE_OFFSET 0x02
#define AC_ENABLE_INC 0x01

#endif
